import os
import cPickle
import time
class ClusterAnalyzer:
	
	def __init__(self):
		"""
		self.dirs=["~/Library/netflixprize/FinalClustering/Kmeans/Output/Clusters","~/Library/netflixprize/FinalClustering/DBSCAN/Output"]
		self.dirs=["Kmeans/Output/Clusters","DBSCAN/Output"]
		self.data={}
		self.data["filenames"]=[]
		for d in self.dirs:
			for a in os.listdir(d):
				if a[0]!=".":
					self.readInFile(d,a)
		print self.data["filenames"]
		for id in self.data:
			print len(self.data[id])
		self.unpickleMetaData()
		for key in self.metaData:
			print key,self.metaData[key]
		for key in self.data:
			print key,self.data[key]
		print "filenames",self.data["filenames"]
		fout=open("clusters.pickle","w")
		cPickle.dump(self.data,fout)
		fout.close()"""
		fin=open("clusters.pickle")
		self.data=cPickle.load(fin)
		fin.close()
		for key in self.data:
			if len(self.data[key])!=39:
				print len(self.data[key])
		self.unpickleMetaData()
		missing=[]
		for key in self.data:
			
			if key!="filenames":
				strippedkey=int(key.strip())
				try:
					self.data[key].append(self.metaData[strippedkey]["genre"])
					self.data[key].append(self.metaData[strippedkey]["title"])

				except:
					self.data[key].append("None")
			else:
				self.data[key].append("genres")
				self.data[key].append("title")
		for key in missing:
			del self.data[key]
		
		for index in range(len(self.data["filenames"])-1):
			c=self.createClusterDictionary(index)
			#self.analyzeCluster(c)
			self.giveMeMovies(c[1])
			time.sleep(10)
		"""fout=open("totalData.pickle","w")
		cPickle.dump(self.data,fout)
		fout.close()"""
	
	def giveMeMovies(self,cluster):
		rv={}
		for i in cluster:
			print len(cluster[i])
			rv[i]=[]
			for tuple in cluster[i]:
				print tuple
				rv[i].append(tuple[1])
				if len(rv[i])>10:
					break
		print rv
	def createClusterDictionary(self,index):
		cluster={}
		for movie in self.data:
			if movie!="filenames":
				myCluster=self.data[movie][index]
				if myCluster in cluster:
					cluster[myCluster].append((movie,self.data[movie][-1]))
				else:
					cluster[myCluster]=[(movie,self.data[movie][-1])]
			else:
				fname=self.data[movie][index]
		return (fname,cluster)
		
	def analyzeCluster(self,(fname,clustering)):
		genres={}
		for clusterid in clustering:
			genres[clusterid]={}
			for tuple in clustering[clusterid]:
				for genre in tuple[1]:
					if genre in genres[clusterid]:
						genres[clusterid][genre]+=1
					else:
						genres[clusterid][genre]=1
		totalhit=0.0
		totallength=0
		for clusterid in genres:
			best=("",None)
			otherbest=("",None)
			
			for genre in genres[clusterid]:
				if genres[clusterid][genre]>best[1]:
					otherbest=best
					best=(genre,genres[clusterid][genre])	
				elif genres[clusterid][genre]>otherbest[1]:
					otherbest=(genre,genres[clusterid][genre])
			hit=0.0
			missing=0
			for tuple in clustering[clusterid]:
				if best[0] in tuple[1] or otherbest[0] in tuple[1]:
					hit+=1
				if "None" in tuple[1]:
					missing+=1
			totalhit+=hit
			totallength+=len(clustering[clusterid])-missing
		print "Data from clustering: ",fname
		print totalhit
		print totallength
		print totalhit/totallength
		
	
					
	def readInFile(self,dir,filename):
		filename=dir+"/"+filename
		fin=open(filename)
		self.data["filenames"].append(filename)
		for line in fin:
			line=line.split(",")
			if len(line)==2:
				if line[1] in self.data:
					self.data[line[1]].append(line[0])
				else:
					self.data[line[1]]=[line[0]]
					
	def unpickleMetaData(self):
		fin=open("genrePickled")
		self.metaData=cPickle.load(fin)
		fin.close()
			
					
				
c = ClusterAnalyzer()