/*
 * DBSCAN.c
 *
 *  Created on: Dec 30, 2009
 *      Author: Sam
 */
 
 #include <stdlib.h>
 #include <math.h>
 #include "knncore.c"
 #include <stdio.h>
 
 float epsilon;
 int minPts;


FILE *fOut;


typedef struct {
	int stars;
} attribute;

typedef struct {
	dbRlist **list;
	int capacity;
	int length;
}rlist_GA;

/*typedef struct {
	rlist_GA;
	int capacity;
	int length;
}Cluster;*/

typedef struct {
	rlist_GA **d;
	int capacity;
	int length;
}Cluster_GA;

/*typedef struct{
	Cluster *cluster;
	int noise;
	int core;
	int border;
	int visited;
	
}DBstruct;*/
pp_rlist_GA(rlist_GA *r){
	int i;
	for(i=0;i<r->length;i++){
		printf("%i,",r->list[i]->id);
	}
	printf("\n");
}

pp_Cluster_GA(Cluster_GA *C){
	int i,j;
	rlist_GA *thisCluster;
	for(i=0;i<C->length;i++){
		thisCluster=C->d[i];
		printf("[%i]",i);
		pp_rlist_GA(thisCluster);
	}
}
rlist_GA *make_rlist_GA(int c){
	rlist_GA *rv=(rlist_GA*)malloc(sizeof(rlist_GA));
	rv->list=(dbRlist**)malloc(sizeof(dbRlist*) * c);
	rv->capacity=c;
	rv->length=0;
	return rv;
}

void write_clusters(FILE *fo, Cluster_GA *C){
	int i,j;
	rlist_GA *thisCluster;
	printf("%i\n",C->length);
	for(i=0;i<C->length;i++){
		thisCluster=C->d[i];
		for(j=0;j<thisCluster->length;j++){
			fprintf(fo,"%i,%i\n",i,thisCluster->list[j]->id);
		}
	}
	for(i=0;i<NMOVIES;i++){
		if(knn_getdbRlist(i)->noise==1){
			printf("%i is NOISE\n",i);
			fprintf(fo,"NOISE,%i\n",knn_getdbRlist(i)->id);
		}
	}
}

rlist_GA *insert_rlist_GA(rlist_GA* a, dbRlist *b){
	int i,in;
	in=0;
	for(i=0;i<a->length; i++){
		if(a->list[i]->id==b->id){
			in=1;
		}
	}
	if(in==1)
		return a;
	if(a->capacity <= a->length){
		a->list=(dbRlist**) realloc(a->list,2*a->capacity*sizeof(dbRlist*));
		a->capacity = a->capacity*2;
	}
	a->list[a->length]=b;
	a->length++;
	return a;
}


void markAsVisited(dbRlist *r){
	r->visited=1;
}

void markAsNoise(dbRlist *r){
	r->noise=1;
}

void markAsBorder(dbRlist *r){
	r->noise=0;
	r->border=1;
}

void markAsCore(dbRlist *r){
	r->noise=0;
	r->core=1;
}

int isVisited(dbRlist *r){
	return r->visited;
}

int isNoise(dbRlist *r){
	return r->noise;
}

int isBorder(dbRlist *r){
	return r->border;
}

int isCore(dbRlist *r){
	return r->core;
}
int inCluster(dbRlist *r){
	return isBorder(r);
}
/*Cluster *make_Cluster(int a){
	Cluster *rv=(Cluster*)malloc(sizeof(Cluster));
	rv->length=0;
	rv->list=make_rlist_GA(a);
	return rv;
}*/
Cluster_GA *make_Cluster_GA(int a){
	Cluster_GA *rv = (Cluster_GA*)malloc(sizeof(Cluster_GA));
	rv->capacity=a;
	rv->length=0;
	rv->d=(rlist_GA**)malloc(a*sizeof(rlist_GA*));
	return rv;
}

Cluster_GA *insert_Cluster_GA(Cluster_GA *a,rlist_GA *b){
	if(a->capacity <= a->length){
		a->d=(rlist_GA**) realloc(a->d,2*a->capacity*sizeof(rlist_GA*));
		a->capacity = a->capacity*2;
	}
	a->d[a->length]=b;
	a->length++;
	return a;
}

/*void insert_Cluster(Cluster *a,dbRlist *b){
	insert_rlist_GA(a->list,b);
}*/

rlist_GA *merge(rlist_GA *a, rlist_GA *b){
	int i;
	for(i=0;i < b->length;i++){
		a=insert_rlist_GA(a,b->list[i]);
	}
	return a;

}

/*float getDistance(rlist *curPoint, rlist *otherPoint){
	float rv;
	int i;
	for(i=0; i<curPoint->length; i++){
		rv+=pow(curPoint->ratings[i].stars,2)+pow(otherPoint->ratings[i].stars,2);
	}
	rv=sqrt(rv);
	return rv;
	  
}


void assignPoints( rlist** points, int length){
	int i,j,num,distance;
	rlist *curPoint,*otherPoint;
	for(i=0; i<length; i++){
		num=0;
		curPoint=points[i];
		for(j=0; j<length; j++){
			otherPoint=points[j];
			distance=getDistance(curPoint,otherPoint);
			if(distance<epsilon){
				num++;
			}
		}
		if(num<minPts){markAsNoise(curPoint);};
	}
}*/

rlist_GA *getNeighbors( dbRlist *pt){
	rlist_GA *rv=make_rlist_GA(5);
	int i;
	dbSNN **list=pt->knn;
	for(i=0;i<pt->length;i++){
		if(list[i]->distance > epsilon){
			//printf("%f\n",list[i]->distance);
			insert_rlist_GA(rv,knn_getdbRlist(list[i]->id));
		}
	}
	insert_rlist_GA(rv,pt);
	return rv;
}

int SNNDistance(dbRlist *pt, dbRlist *otherPt){
	int i,j,count,curId;
	count=0;
	for(i=0;i<pt->length;i++){
		curId=pt->knn[i]->id;
		j=0;
		while(j<otherPt->length){
			
			if(otherPt->knn[j]->id==curId){
				
				count++;
				j=otherPt->length;
				}
			j++;
		}
	}
	return count;	
}
rlist_GA *getSNNNeighbors(dbRlist *pt){
	rlist_GA *rv=make_rlist_GA(5);
	int i,j;
	for(i=0;i<NMOVIES;i++){
		if(SNNDistance(pt,knn_getdbRlist(i))>epsilon){
			insert_rlist_GA(rv,knn_getdbRlist(i));
		}
	}
	
	return rv;
}


rlist_GA *expandCluster(rlist_GA *C, dbRlist *pt, rlist_GA *N){
	insert_rlist_GA(C,pt);
	markAsBorder(pt);
	markAsCore(pt);
	int i;
	dbRlist *nextPoint;
	rlist_GA *newNeighbors;//Neighbors
	for(i=0;i<N->length;i++){
		
		nextPoint=N->list[i];
		
		if(!isVisited(nextPoint)){
			printf("Expanding movie: %i\n",nextPoint->id);
			markAsVisited(nextPoint);
			
			newNeighbors=getSNNNeighbors(nextPoint);
			if(newNeighbors->length >= minPts){
				N=merge(N,newNeighbors);
				markAsCore(nextPoint);
			}
		}
		if(!inCluster(nextPoint)){
			markAsBorder(nextPoint);
			C=insert_rlist_GA(C,nextPoint);
		}
	}
	printf("Nlength: %i\n",N->length);
	return C;
}

Cluster_GA *DBSCAN(){
	//Make array of Clusters to grow
	Cluster_GA *C=make_Cluster_GA(5);
	rlist_GA *tempCluster;
	int i;
	rlist_GA *N;
	dbRlist *nextPoint;
	for(i=0; i<NMOVIES;i++){
		nextPoint=knn_getdbRlist(i);
		
		if(!isVisited(nextPoint)){
			printf("Scanning: %i",nextPoint->id);
			markAsVisited(nextPoint);
			N=getSNNNeighbors(nextPoint);
			if(N->length<minPts){
				printf(" which is noise\n");
				markAsNoise(nextPoint);
			}
			else{
				printf(" which starts a cluster\n");
				tempCluster = make_rlist_GA(5);
				tempCluster=expandCluster(tempCluster,nextPoint,N);
				C=insert_Cluster_GA(C,tempCluster);
			}
		}
	}
	return C;

}

int main(int argc, char** argv) {
	char result[50] ="Output/";
	epsilon = atof(argv[1]);
	minPts=atoi(argv[2]);
	printf("%f, %i\n",epsilon,minPts);
	printf("Allocating\n");
	knn_allocate();
	printf("Loading\n");
	knn_load();
	printf("Done Loading\n");
	Cluster_GA *clusters=DBSCAN();
	printf("%i\n",clusters->length);
	//pp_Cluster_GA(clusters);
	printf("%i\n",argc);
	
	if(argc==4)
		strcat(result,argv[3]);
	else
		sprintf(result,"Output/%i.%.3f.%i.txt",clusters->length,epsilon,minPts);
	printf("%i\n",clusters->length);

	
	printf(result);
	printf("\n");
	fOut=fopen(result,"w");
	
	printf(result);
	printf("\n");
	
	printf("here\n");
	write_clusters(fOut,clusters);
	//pp_data();
	fclose(fOut);
}
