#include <stdio.h>   /* required for file operations */
#include <string.h>
#include <stdlib.h>
#include "knncore.h"


dbSNN *make_dbSNN(int id, float distance){
	dbSNN *rv=(dbSNN*)malloc(sizeof(dbSNN));
	rv->id=id;
	rv->distance=distance;
	return rv;
}

dbRlist *make_dbRlist(int *ids, float *distances, int length,int rlistId){
	dbRlist *rv=(dbRlist*)malloc(sizeof(dbRlist));
	rv->knn=(dbSNN**)malloc(sizeof(dbSNN*)*length);
	rv->length = length;
	int i;
	for(i=0;i<length;i++){
		rv->knn[i]=make_dbSNN(ids[i],distances[i]);
	}
	rv->id=rlistId;
	rv->noise=0;
	rv->core=0;
	rv->border=0;
	rv->visited=0;
	return rv;
}

pp_dbRlist(dbRlist *r){
	int i;
	printf("ID: %i vnoise:%i core:%i border%i visited:%i",r->id,r->noise,r->core,r->border,r->visited);
	for(i=0;i<r->length;i++){
		printf(" [%i,%f]",r->knn[i]->id,r->knn[i]->distance);
	}
	printf("\n");
}

inline dbRlist *knn_getdbRlist(int i){
	return knn_data.data[i];
}

pp_data(){
	int i;
	for(i=0;i<NMOVIES; i++){
		printf("[%i] ",i);
		pp_dbRlist(knn_getdbRlist(i));
	}
}
int knn_allocate(){
	knn_data.data=(dbRlist**)malloc(sizeof(dbRlist*)*NMOVIES);
}

int knn_load(){
	FILE *fr; 
 	int i,n;
   long elapsed_seconds;
   char line[1610];
   char *tokenized;
   int rlistid;
   int newId;
   float newDist;
   int *id=(int*)malloc(sizeof(int)*100);
   float *dist=(float*)malloc(sizeof(float)*100);
   fr = fopen ("knnfinal.txt", "r+");  /* open the file for reading */
   /* elapsed.dta is the name of the file */
   /* "rt" means open the file for reading text */
	n=0;
	while(fgets(line,sizeof(line),fr)!=NULL){
   		
   		tokenized=strtok(line,"\t");
   		sscanf(tokenized,"%i",&rlistid);
   		i=0;
   		while(tokenized!=NULL && i<100){
   			tokenized=strtok(NULL,"\t");
   			sscanf(tokenized,"%i,%f",&newId,&newDist);
   			id[i]=newId;
   			dist[i++]=newDist;
   			
   		}
   		knn_data.data[n++]=make_dbRlist(id,dist,100,rlistid);
	 /* get a line, up to 80 chars from fr.  done if NULL */
	 //sscanf (line, "%ld", &elapsed_seconds);
	 /* convert the string to a long int */
	 //printf ("%ld\n", elapsed_seconds);
	 //printf("%s\n",line);
   	}
   fclose(fr);  /* close the file prior to exiting the routine */
   
}

int knn_cleanup(){
	
};


