"""
Read out data to sockets
Choose Cluster Centers
While error <threshold
	Send Cluster Centers
	Get Cluster Centers
	Merge Cluster Centers
	Check Error

"""




from socket import *
import random
import time
myPorts=range(2000)[2000:]
"""mySocks=[]
myCons=[]
myData={}
for port in myPorts:
	myHost = "localhost"
	myPort = port
	
	s = socket(AF_INET, SOCK_STREAM)    # create a TCP socket
	mySocks.append(s)
	s.bind((myHost, myPort))            # bind it to the server port
	s.listen(5)                         # allow 5 simultaneous
										# pending connections
for s in mySocks:
		connection, address = s.accept() # connection is a new socket
		myCons.append(connection)
		myData[connection]=[]
		
for connection in myCons:
	data = connection.recv(1024) # receive up to 1K bytes
	if data:
		myData[connection].append(data)
		
for connection in myCons:
	data=myData[connection][0]
	connection.send("echo -> " + data)
print myData"""
class Movie:
	def __init__(self,line):
		line = line.split("\t")
		self.ratings={}
		for x in line[2:]:
			
			x=x.split(",")
			if len(x)!=2:
				print x
			else:
				self.ratings[int(x[0])]=float(x[1])
		self.id=int(line[0])
		
class ServerCluster:
	def __init__(self,line):
		self.numIn=0
		line=line.split("\t")
		self.error=float(line[0])
		line=line[1:]
		self.ratings=dict( [ ( int(x.split(",")[0]) , float(x.split(",")[1]) ) for x in line ] )
		
	def addLine(self,line):
		line=line.split("\t")
		numIn=int(line[1])
		self.numIn+=numIn
		self.error+=float(line[0])
		line=line[2:]
		r=dict([( int(x.split(",")[0]) , float(x.split(",")[1])*numIn) for x in line])
		for id in r:
			if id in self.ratings.keys():
				self.ratings[id]+=r[id]
			else:
				self.ratings[id]=r[id]
	
	def average(self):
		for r in self.ratings:
			self.ratings[r]/=self.numIn
	
	def clear(self):
		self.ratings={}
		self.numIn=0
		
	def __str__(self):
		rv=""
		for id in self.ratings:
			rv+=str(id)+","+str(self.ratings[id])+"\t"
		rv.strip()
		return rv
		

class kmeansServer:
	def __init__(self,myPorts,k):
		self.myPorts=myPorts
		self.myCons=[]
		self.mySocks=[]
		self.myData={}
		self.k=k
		self.clusters=[]	
	
	def initSockets(self):
		myHost=""
		for port in self.myPorts:
			s= socket(AF_INET, SOCK_STREAM)
			self.mySocks.append(s)
			s.bind((myHost,port))
			s.listen(5)
			
			
	def connectSockets(self):
		for i in range(len(self.mySocks)):
			s=self.mySocks[i]
			print i,s.getsockname()
			connection, address = s.accept()
			print i,s.getsockname()
			print connection.getsockname()
			self.myCons.append(connection)
			
	def sendMovieData(self,fin):
		initIndex=random.sample(range(800),self.k)
		print initIndex
		time.sleep(3)
		connIndex=0
		i=0
		for line in fin:
			if i in initIndex:
				t=ServerCluster(line)
				self.clusters.append(ServerCluster(line))
			data=None
			self.readLine(self.myCons[connIndex])
			self.myCons[connIndex].send(line)
			connIndex+=1
			connIndex=connIndex%len(self.myCons)
			i+=1
		for con in self.myCons:
			self.readLine(con)
			con.send("STOP\n")
			
	def readLine(self,soc):
		data=soc.recv(1024)
		while data[-1]!="\n":
			data+= soc.recv(1024)
		return data.strip()
		
	def receiveClusterCenters(self):
		notReceived=[con for con in self.myCons]
		connIndex=0
		self.clearClusters()
		for cluster in self.clusters:
			for con in self.myCons:
				con.send("READY\n")
				data=self.readLine(con)
				while data=="READY":
					data=self.readLine(con)
				cluster.addLine(data)
		
	def clearClusters(self):
		for c in self.clusters:
			c.clear()
			
	def updateClusterAverages(self):
		for cluster in self.clusters:
			cluster.average()
	
	def sendClusterCenters(self):
		print "SENDING CLUSTERS"
		connIndex=0
		for cluster in self.clusters:
			for con in self.myCons:
				self.readLine(con)
				con.send(str(cluster)+"\n")
		for con in self.myCons:
			self.readLine(con)
			con.send("STOP\n")
				
	def initClusterCenters(self):
		random.sample(range(100))
	
	def sendMessageOut(self,m):
		for con in self.myCons:
			con.send(m)
		
	def kmeans(self,threshold):
		
		self.sendClusterCenters()
		self.receiveClusterCenters()
		self.updateClusterAverages()
		error=0
		for c in self.clusters:
			error+=c.error
		perror=999999999999
		while perror-error > threshold:
			self.sendMessageOut("GO\n")
			perror=error
			self.sendClusterCenters()
			self.receiveClusterCenters()
			self.updateClusterAverages()
			error=0
			for c in self.clusters:
				error+=c.error
			print "ERROR: ",error,"PERROR: ",perror
		self.sendMessageOut("STOP\n")
		print "DONE"
		
	def closeSockets(self):
		for con in self.myCons:
			con.close()
		for soc in self.mySocks:
			soc.close()
		

fileIn=open("standardizedMatrix.txt")
server=kmeansServer([2001,2002,2003],5)
print 1
server.initSockets()
print 2
server.connectSockets()
print 3
server.sendMovieData(fileIn)
server.kmeans(1)

for c in server.clusters:
	print c.error
	time.sleep(1)
server.closeSockets()
				