/*
 *  naiveknn.h
 *  
 *
 *  Created by  on 1/23/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */
#include <stdlib.h>
#include "netflixcore.c"
#include <stdio.h>
#include <math.h>
#include <time.h>
FILE *fileout;

typedef struct {
	rlist **heap;
	int capacity;
	int length;
} rlistHeap;

typedef struct {
	float dist;
	int id;
} distHolder;

rlistHeap *make_rlistHeap(int mx){
	rlistHeap *rv=(rlistHeap*)malloc(sizeof(rlistHeap));
	rv->heap=(rlist**)malloc(sizeof(rlist*)*mx+1);
	rv->capacity=mx;
	rv->length=0;
	return rv;
}

distHolder *make_distHolder(float d,int id){
	distHolder *rv=(distHolder*)malloc(sizeof(distHolder));
	rv->dist=d;
	rv->id=id;
	return rv;
}


void insertHeap( rlistHeap *h, rlist *element){
	int i,j;
	if(h->capacity==h->length){
		printf("Heap full\n");
		return;
	}
	h->length++;
	if(h->length==1){
		h->heap[1]=element;
		return;
	}
	i=h->length;
	
	while(i>1 && ((distHolder*)h->heap[i/2]->additional)->dist > ((distHolder*) element->additional)->dist){

		h->heap[i]=h->heap[i/2];
		i=i/2;
	}

	h->heap[i]=element;
}


void replaceMin(rlistHeap *h, rlist *new){
	int i,child;
	for(i=1; i *2 <= h->length; i = child){
		child = i*2;
		if( child != h->length && (((distHolder*) h->heap[child+1]->additional )->dist < ( (distHolder*)h->heap[child]->additional)->dist )){
			child ++;
		}
		if( ((distHolder*) new->additional)->dist > ((distHolder*)h->heap[child]->additional)->dist )
			h->heap[i]=h->heap[child];
		else
			break;
	}
	h->heap[i]=new;
}

rlist *popMin(rlistHeap *h){
	int i, child;
	rlist *min,*last;
	if(h->length==0){
		return NULL;
	}
	min=h->heap[1];
	last=h->heap[h->length--];
	
	replaceMin(h,last);
	
	return min;
	
}



rlist *peekHeap(rlistHeap *h){
	if(h->length>0)
		return h->heap[1];
	else
		return NULL;
}
int dotProductrlist(rlist *a, rlist *b){
	int i,j,id;
	int sum=0;
	j=0;
	for(i=0;i<a->length;i++){
		id=a->ratings[i].id;
		while(j<=b->length && b->ratings[j].id<id)
			j++;
		if(b->ratings[j].id==id)
			sum+=a->ratings[i].stars * b->ratings[j].stars;
	}
	//printf("sum: %i",sum);
	return sum;
}


float cosineDistance(rlist *a, rlist *b){
	float rv;
	if(a->length > b->length)
		rv=dotProductrlist(a,b);
	else
		rv=dotProductrlist(b,a);
	
	rv /= (sqrt(dotProductrlist(a,a))*sqrt(dotProductrlist(b,b)));
	return rv;
}


pp_rlist(rlist *r){
	fprintf(fileout,"%i,%f\t",((distHolder*) r->additional)->id,((distHolder*) r->additional)->dist);
}
pp_rlistHeap(rlistHeap *h,int i){
	rlist *temp;
	fprintf(fileout,"%i\t",i);
	float last=-1;
	while(h->length>0){
		temp=popMin(h);
		pp_rlist(temp);
		if(last>((distHolder*) temp->additional)->dist)
			fprintf(stderr,"Heap error\n");
		last=((distHolder*) temp->additional)->dist;
	}
	
}
void printKNN(int i, int k,rlistHeap *nnHeap){
	rlist *movie=nf_ratingsformovie(i);
	rlist *temp;

	float distance;
	int j;
	for(j=0;j<NMOVIES;j++){
		//printf("Hello printknn %i\n",j);
		if(j!=i){
			
			temp=nf_ratingsformovie(j);
			//printf("got movie: %i with %i ratings\n",j,temp->length);
			distance = cosineDistance(movie,temp);
			//printf("distance: %f\n",distance);
			if(temp->additional == NULL)
				temp->additional=make_distHolder(distance,j);
			else
				((distHolder*)temp->additional)->dist=distance;
			//pp_rlist(temp);
			//printf("\n");
			if(distance>0.0){
				if(nnHeap->length<k)	
					insertHeap(nnHeap,temp);
				else if(distance > ((distHolder*)peekHeap(nnHeap)->additional)->dist)
					replaceMin(nnHeap, temp);
				}
			//printf("nnheap size: %i, capacity: %i min: %f\n",nnHeap->length,nnHeap->capacity,((distHolder*)peekHeap(nnHeap)->additional)->dist);
		}
	}
	pp_rlistHeap(nnHeap,i);
	fprintf(fileout,"\n");
	fflush(fileout);
}
void knn(int k, int start){
	int i;
	
	time_t start, stop, loaded;
	struct tm *timeinfo;

	time(&start);
	timeinfo = localtime(&start);
	fprintf(stderr,"%s\n", asctime(timeinfo));
	rlistHeap *nnHeap=make_rlistHeap(k);
	//printf("nnheap size: %i, capacity: %i\n",nnHeap->length,nnHeap->capacity);
	for(i=start;i<NMOVIES;i++){
		if(i%100==0) {
			time(&stop); 
			fprintf(stderr,"At movie: %i Time elapsed: %f\n",i,difftime(stop, start));
		}
		printKNN(i,k,nnHeap);
		nnHeap->length=0;
	}
}

int main(int argc, char** argv){
	fileout=fopen(argv[2],"w");
	nf_allocate();
	nf_load();
	fprintf(stderr,"Loaded\n");
	knn(100,atoi(argv[1]));
	fclose(fileout);

}
