#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "netflixcore.c"


#define INFIN 99999.0
int k;
int ensembleSize;
#define filename "skmeans4.txt"
int METRIC;//1 is Cosine, 0 is Euclidean
int WRITE; //1 means write the matrix
int CLUSTERUSERS; //1 means cluster movies
int XAXIS;
int YAXIS;
FILE *fileout;
FILE *clustersOut;

typedef struct {
  float stars;
} dimension;

//typedef struct {
 // int length;      /* number of ratings */
 // dimension *ratings; /* array of ratings */
//} rlist;


//typedef struct {
//  int id;                  /* Either the movie or user id */
//  unsigned int stars : 3;  /* The # of stars */
//  unsigned int date : 12;  /* Date (days after Dec 31st 1999) */
//  unsigned int visible: 1; /* Flag for training/testing */
//} rating;*/

typedef struct {
	unsigned int id:20;
	float stars;
	void *next;
	int numberIn;
}RatingLL;

typedef struct {
	int id;
	float stars;
} floatRating;




typedef struct{
	float *ratings;
	//RatingLL *ratings;
	int length;
	int numberIn;
	float magnitude;
} Centroid;

typedef struct {
	floatRating *ratings;
	int length;
	Centroid **c;
	int bag;
}floatRlist;





floatRlist **MOVIES;

void pp_array(float *a){
	int j;
	printf("(");
	for(j=0;j<XAXIS;j++){
		if(a[j]!=0.0&&a[j]==a[j])
			printf(" {%i,%f}  ",j+1,a[j]);
	}
	printf(")\n");

}
void pp_rlist(rlist *a){
	int j;
	printf("(");
	for(j=0;j<a->length;j++){
		printf(" {%i,%i}  ",a->ratings[j].id,a->ratings[j].stars);
	}
	printf(")\n");
}



void write_floatRlist(int id,floatRlist *a,FILE *fi){
	int j;
	fprintf(fi,"%i",id);
	for(j=0;j<a->length;j++){
		fprintf(fi,"\t%i,%f",a->ratings[j].id,a->ratings[j].stars);
	}
	fprintf(fi,"\n");
	fflush(fi);
}

void pp_Centroid(Centroid *a){
	int j;
	fprintf(fileout,"(");
	fprintf(fileout,"(numin: %i",a->numberIn);
	for(j=0;j<XAXIS;j++){
		if(a->ratings[j]!=0.0)
			fprintf(fileout," {%i,%f}  ",j+1,a->ratings[j]);
	}
	fprintf(fileout,")\n");
	fflush(fileout);
}

void pp_floatRlist(floatRlist *a){
		int j;
	printf("(");
	for(j=0;j<a->length;j++){
		printf(" {%i,%f}  ",a->ratings[j].id,a->ratings[j].stars);
	}
	printf(")\n");
}

void write_clusters(FILE *fo, Centroid **C){
	int i,j;
	for(i=0;i<k;i++){
		for(j=0;j<YAXIS;j++){
			if(MOVIES[j]->c[0]==C[i]){
				fprintf(fo,"%i,%i\n",i,j);
			}
		}
		fprintf(fo,"\n");
	}
}

/*void pp_Centroid(Centroid *c){
	RatingLL *t;
	t=c->ratings;
	printf("(numin: %i",c->numberIn);
	while(t!=NULL){
		printf(" (id: %i, stars: %f, numin: %i) ",t->id,t->stars,t->numberIn);
		t=t->next;
	}
	printf(")\n"); 
}*/

void pp_CentroidList(Centroid **c){
	int i;
	for(i=0;i<k;i++){
		fprintf(fileout,"[%i]",i);
		pp_Centroid(c[i]);
	}
}	

float getMean(rlist *a){
	float rv=0.0;
	int i,count;
	count=0;
	for(i=0;i<a->length; i++){
		if(a->ratings[i].visible){count++;rv+=a->ratings[i].stars;}
	}
	if(count==0) 
		return 0.0;
	
	return rv/count;
}
float getStdDev(rlist *a, float mean){
	
	float rv=0.0;
	int i,count;
	count=0;
	for(i=0;i<a->length;i++){
		if(a->ratings[i].visible){
			count++;
			rv+=pow(a->ratings[i].stars-mean,2);
			}
	}
	if(count==0) 
		return 0.0;
	return sqrt(rv/a->length);
}

float *getMeans(){
	float *rv=(float*)malloc(sizeof(float)*XAXIS);
	int i;
	printf("MEANS\n");
	for(i=0;i<XAXIS;i++){
		if(CLUSTERUSERS)
			rv[i]=getMean(nf_ratingsformovie(i));
		else
			rv[i]=getMean(nf_ratingsforuser(i));
			
	}
	return rv;
}

float *getStdDevs(float *means){
	printf("STDDEV\n");
	float *rv=(float*)malloc(sizeof(float)*XAXIS);
	int i;
	for(i=0;i<XAXIS;i++){
		if(CLUSTERUSERS)
			rv[i]=getStdDev(nf_ratingsformovie(i),means[i]);
		else
			rv[i]=getStdDev(nf_ratingsforuser(i),means[i]);
	}
	return rv;
}
floatRlist *getStandardizedRlist(rlist *a,float *stdDevs,float *means){
	floatRlist *rv=(floatRlist*)malloc(sizeof(floatRlist));
	
	rv->ratings=(floatRating*)malloc(sizeof(floatRating)*a->length);
	rv->length=a->length;
	rv->bag=1;
	rv->c=(Centroid**)malloc(sizeof(Centroid*)*ensembleSize);
	float t;
	int i,j,id;
	j=0;
	for(i=0;i<a->length;i++){
		if(a->ratings[i].visible){
			rv->ratings[j].id=a->ratings[i].id;
			if(stdDevs[a->ratings[i].id]!=0.0)
				rv->ratings[j].stars=(a->ratings[i].stars - means[a->ratings[i].id])/stdDevs[a->ratings[i].id];
			else
				rv->ratings[j].stars=0.0;
			j++;
			}
	}
	
	rv->length=j;
	return rv;
}

void rebag(){
	int i,b;
	for(i=0;i<YAXIS;i++){
		b=rand()%10;
		if(b>5)
			b=0;
		MOVIES[i]->bag=b;
	}
}

float dotArray(float *a, float *b){
	float rv=0.0;
	int i;
	for(i=0;i<XAXIS;i++){
		rv+=a[i]*b[i];
	}
	if(rv!=rv){
		printf("%f\n",rv);
		exit(1);
	}
	
	return rv;
}

float dotRlistArray(float *array, floatRlist *r){
	float rv=0.0;
	int i;
	for(i=0;i<r->length;i++){
		rv+=array[r->ratings[i].id-1]*r->ratings[i].stars;
	}
	if(rv!=rv){
		printf("%f\n",rv);
		exit(1);
	}
	
	return rv; 
}

float dotRlist(floatRlist *a, floatRlist *b){
	int i,j,id;
	float sum=0.0;
	j=0;
	for(i=0;i<a->length;i++){
		id=a->ratings[i].id;
		while(j<=b->length && b->ratings[j].id<id)
			j++;
		if(b->ratings[j].id==id)
			sum+=a->ratings[i].stars * b->ratings[j].stars;
	}
	//printf("sum: %i",sum);
	return sum;
}

floatRlist *rlistToFloatRlist(rlist *a,float *means, float *stdDevs){
	floatRlist *rv=getStandardizedRlist(a,stdDevs,means);
	if(METRIC!=1)
		return rv;
	float dotted=dotRlist(rv,rv);
	
	float magnitude=sqrt(dotted);
	if(magnitude==0.0){
		return rv;
		}
	else{
		int i;
		for(i=0;i<rv->length;i++){
			rv->ratings[i].stars/=magnitude;
			if(rv->ratings[i].stars!=rv->ratings[i].stars){
				break;	
			}
		}
		if(i!=rv->length)
			printf("ERROR: %f,%f,%f\n",rv->ratings[i].stars,magnitude,dotted);
		return rv;
	}
	
}

floatRlist **initRatingMatrix(){
	
	floatRlist **rv=(floatRlist**)malloc(sizeof(floatRlist*)*YAXIS);
	
	float *means=getMeans();
	printf("%i,%i\n",XAXIS,YAXIS);
	float *stdDevs=getStdDevs(means);
	printf("X:%i,Y:%i\n",XAXIS,YAXIS);
	int i;
	for(i=0;i<YAXIS;i++){
		
		if(CLUSTERUSERS)
			rv[i]=rlistToFloatRlist(nf_ratingsforuser(i),means,stdDevs);
		else
			rv[i]=rlistToFloatRlist(nf_ratingsformovie(i),means,stdDevs);
		}
	return rv;
}
void clearCentroid(Centroid *c){
	int i;
	for(i=0; i<XAXIS; i++){
		c->ratings[i]=0.0;
	}
	c->numberIn=0;
}
Centroid *makeCentroid(){
	Centroid *rv= (Centroid*)malloc(sizeof(Centroid));
	rv->length=0;
	rv->numberIn=0;
	rv->ratings=(float*)malloc(sizeof(float)*XAXIS);
	//rv->nums=(int*)malloc(sizeof(int)*XAXIS);
	clearCentroid(rv);
	rv->magnitude=0.0;
	return rv;
}


RatingLL *make_RatingLL(int id){
	RatingLL *rv=(RatingLL*)malloc(sizeof(RatingLL));
	if(rv==NULL){
		fprintf(stderr,"can't malloc: %i\n",id); return NULL;
	}
	rv->id=id;
	rv->next=NULL;
	rv->stars=0;
	rv->numberIn=1;
	return rv;
}
Centroid *initCentroid(int x){
	printf("Initializing a Centroid with: ");
	pp_floatRlist(MOVIES[x]);
	
	printf("IN initCentroid\n");
	Centroid *rv= makeCentroid();
	int i,j,id;
	j=0;
	id=MOVIES[x]->ratings[j].stars;
	for(i=0;i<MOVIES[x]->length;i++){
		rv->ratings[MOVIES[x]->ratings[i].id-1]=MOVIES[x]->ratings[i].stars;
	}
	printf("done initCentroid\n");
	rv->magnitude=dotArray(rv->ratings,rv->ratings);
	return rv;
}
RatingLL *insertRatingLL(Centroid *c,RatingLL *cur, int id){
	if(cur->next == NULL){
		cur->next= make_RatingLL(id);
		c->numberIn++;
		return cur->next;
	}
	if( ((RatingLL*)cur->next)->id > id ){
		RatingLL *temp= (RatingLL*)cur->next;
		cur->next= make_RatingLL(id);
		((RatingLL*)cur->next)->next = temp;
		c->numberIn++;
		return cur->next;
	}
	else
		return insertRatingLL(c,cur->next,id);
}




void updateCentroid(Centroid *c, floatRlist *a){
	int i;
	for(i=0;i<a->length;i++){
		c->ratings[a->ratings[i].id-1]+=a->ratings[i].stars;
	}
	c->numberIn++;
	
}


void freeRatings(RatingLL *t){
	if(t->next != NULL){
		freeRatings(t->next);
	}
	free(t);
}
void clearCentroids(Centroid **Centroids){
	int i;
	for(i=0;i<k;i++){
		clearCentroid(Centroids[i]);
	}
}

void addToCentroid(Centroid *c,int id){
	int i;
	updateCentroid(c,MOVIES[id]);

	c->numberIn++;
	//printf("Done Adding\n");
}

void updateCentroidAverage(Centroid *c){
	if(c->numberIn==0){
		free(c);
		c=initCentroid(rand()%YAXIS);
		c->numberIn=1;
	}
	int i;
	for(i=0; i<XAXIS; i++){
		c->ratings[i]/=c->numberIn;
	}
	float mag=dotArray(c->ratings,c->ratings);
	c->magnitude=mag;
		
	if (METRIC!=1){
		return;
	}
	mag=dotArray(c->ratings,c->ratings);
	mag=sqrt(mag);
	for(i=0;i<XAXIS;i++){
		c->ratings[i]/=mag;
	}
}


void updateCentroids(Centroid **Centroids,int run){
	clearCentroids(Centroids);
	int i,j;
	for(i=0; i<YAXIS; i++){
		for(j=1;j<=MOVIES[i]->bag;j++)
			updateCentroid(MOVIES[i]->c[run],MOVIES[i]);
		//addToCentroid(i);
		//pp_CentroidList(Centroids,k);
	}
	for(i=0;i<k;i++){
		updateCentroidAverage(Centroids[i]);
	}		
}



float cosineDistance(float *a, floatRlist *b){
	float rv;
	rv=dotRlistArray(a,b);
	return rv;
}

float euclideanDistance(float *array, floatRlist *r) {
	float rv=0.0;
	float t;
	int i, cur;
	cur=0;
	int id=r->ratings[cur].id-1;
	float stars=r->ratings[cur].stars;
	for(i=0;i<r->length;i++){
		id=r->ratings[i].id-1;
		stars=r->ratings[i].stars;
		
		rv+=(array[id]-stars)*(array[id]-stars);
		rv-=(array[id])*(array[id]);
	}
	return rv; 

}




float findClosestCentroid(Centroid **Centroids,int id,int run){	
	int i;
	float dist;
	floatRlist *b=MOVIES[id];
	float t=0.0;
	if(METRIC==1)
		dist=cosineDistance(Centroids[0]->ratings,b);
	else
		dist=euclideanDistance(Centroids[0]->ratings,b);
		dist+=Centroids[0]->magnitude;
	b->c[run]=Centroids[0];
	for(i=1;i<k; i++){
		if(METRIC==1){
			t=dotRlistArray(Centroids[i]->ratings,b);
			if(t>dist){
				dist=t;
				b->c[run]=Centroids[i];			
			}
		}
		else{
			t=euclideanDistance(Centroids[i]->ratings,b);
			t+=Centroids[i]->magnitude;
			if(t<dist){
				dist=t;
				b->c[run]=Centroids[i];			
			}
		}
		
		
	}
	return dist;
}




Centroid **initCKmeans(){
	printf("initializing\n");
	Centroid **rv= (Centroid **) malloc(sizeof(Centroid*)*k);
	int i;
	for(i=0; i<k;i++){
		rv[i]=initCentroid(rand()%YAXIS);
		printf("New Centroid: ");
		pp_Centroid(rv[i]);
		printf("MAGNITUDE: %f\n",rv[i]->magnitude);
	}
	printf("init complete\n");
	return rv;
}
Centroid **kmeans(int run){
	
	// a is an array of rlists representing the data. It has size n. We are trying to find k clusters
	
	int i;
	Centroid **Centroids=initCKmeans();
	//pp_CentroidList(Centroids);
	
	float j;
	float perror=99999999999.0;
	float error=0.0;
	float threshold=.1;
	do {
		perror=error;
		error=0.0;
		for(i=0; i<YAXIS;i++){
			j=findClosestCentroid(Centroids,i,run);
			if(METRIC==1){
				error-=j;
			}
			else
				error+=j;
				
			if(error!=error){
				pp_floatRlist(MOVIES[i]);
				printf("error: %f\n",error);
				printf("dist: %f\n",j);
				exit(1);
			}
			
			
		}
		if(error>perror){
			printf("NOT CONVERGING\n");}
		printf("outside loop\n");
		fprintf(stderr,"\t Done error: %f\n",error);
		updateCentroids(Centroids,run);
		//pp_CentroidList(Centroids);
		fprintf(fileout,"error: %f\n",perror);
	}while(abs(perror-error)>threshold);
	return Centroids;
}

void writeMatrix(char *mfilename){
	FILE *matrixFile=fopen(mfilename,"w");
	int i;
	
	
	for(i=0;i<YAXIS;i++)
		write_floatRlist(i,MOVIES[i],matrixFile);
}

float predict(int userid, int movieid){
	rlist *userrlist;
	if(CLUSTERUSERS)
		userrlist=nf_ratingsformovie(userid);
	else
		userrlist=nf_ratingsforuser(userid);
	float prediction,mean,std,eprediction;
	Centroid *centroid;
	int i;
	eprediction=0.0;
	for(i=0;i<ensembleSize;i++){
		centroid=MOVIES[movieid]->c[i];
		prediction = centroid->ratings[movieid];
		
		mean=getMean(userrlist);
		std=getStdDev(userrlist,mean);
		prediction=prediction*std+mean;
		eprediction+=prediction;
	}
	return eprediction/ensembleSize;
}

int voteOn(int userid, int movieid){
	int *votes = (int*)malloc(sizeof(int)*5);
	votes[0]=0;
	votes[1]=0;
	votes[2]=0;
	votes[3]=0;
	votes[4]=0;
	rlist *userrlist;
	if(CLUSTERUSERS)
		userrlist=nf_ratingsformovie(userid);
	else
		userrlist=nf_ratingsforuser(userid);
	float prediction,mean,std,eprediction;
	Centroid *centroid;
	int i;
	eprediction=0.0;
	for(i=0;i<ensembleSize;i++){
		centroid=MOVIES[movieid]->c[i];
		prediction = centroid->ratings[movieid];
		
		mean=getMean(userrlist);
		std=getStdDev(userrlist,mean);
		prediction=prediction*std+mean;
		votes[(int)roundf(prediction)-1]++;
		eprediction+=prediction;
	}
	int rv=0;
	for(i=1;i<5;i++){
		if(votes[i]>votes[rv])
			rv=i;
	}
	return rv+1;
}

void test(){
	int user,movie,actual,count,vote;
	float prediction,rmse,totalrmse,hit,close;
	rlist *userRlist;
	totalrmse=0.0;
	count=0;
	hit=.0;
	close=.0;
	for(user=0;user<XAXIS/2;user++){
		if(CLUSTERUSERS)
			userRlist=nf_ratingsformovie(user);
		else
			userRlist=nf_ratingsforuser(user);
		for(movie=0;movie<userRlist->length;movie++){
			if(!userRlist->ratings[movie].visible || 1){
				printf("%i,%i\n",user,userRlist->ratings[movie].id);
				prediction=predict(user,userRlist->ratings[movie].id);
				vote=voteOn(user,userRlist->ratings[movie].id);
				if(vote==userRlist->ratings[movie].stars){
					hit++;
				}
				if(abs(userRlist->ratings[movie].stars-vote)<=1){
					close++;
				}
				actual=userRlist->ratings[movie].stars;
				rmse=(prediction-actual)*(prediction-actual);
				totalrmse+=rmse;
				printf("%i,%i,%i,%f,%f\n",user,userRlist->ratings[movie].id,userRlist->ratings[movie].stars,prediction,rmse);
				count++;
				}
		}
	}
	printf("%f\n",totalrmse);
	printf("%i\n",hit);
	printf("%i\n",count);
	printf("RMSE: %f\n",sqrt(totalrmse/count));
	prediction=hit/count;
	printf("HIT RATING: %f\n",prediction);
	prediction=close/count;
	printf("CLOSE RATING: %f\n",prediction);
}

int main( int argc, char** argv){
	CLUSTERUSERS=atoi(argv[7]);
	if(CLUSTERUSERS){
		XAXIS=NMOVIES;
		YAXIS=NUSERS;
	}
	else{
		XAXIS=NUSERS;
		YAXIS=NMOVIES;
	}
	ensembleSize=atoi(argv[6]);
	k=atoi(argv[1]);
	METRIC=atoi(argv[2]);
	WRITE=atoi(argv[3]);
	srand(time(NULL));
	char result[20];
	sprintf(result,argv[4],k,METRIC);
	Centroid **c;
	char dumpfilename[50]="Output/Dumps/";
	strcat(dumpfilename,argv[4]);
	fileout=fopen(dumpfilename,"w");
	printf("allocating\n");
	if(nf_allocate() != 0){
    	exit(1);
  	}
  	printf("loading\n");
  	if(nf_load() != 0){
    	exit(1);  	

  	}
  	//nf_hidetestset(rand()%100);
  	printf("test\n");
  	MOVIES=initRatingMatrix();
	printf("starting\n");
	c=kmeans(0);
	fprintf(fileout,"\n\n\nKMEANS DONE\n\n\n-------------\n");
	pp_CentroidList(c);
	int run;
	for(run=1;run<ensembleSize;run++){
		//rebag();
		kmeans(run);
		printf("\n\nDONE WITH A RUN\n\n");
	}
	if(WRITE==1)
		if(METRIC==1)
			writeMatrix("Output/Matricies/normalizedMatrix.txt");
		else
			writeMatrix("Output/Matricies/standardizedMatrix.txt");
	
	sprintf(result,"%i.%i.txt",k,METRIC);
	printf(result);
	printf("\n");
	char clusterfilename[50]="Output/Clusters/";
	strcat(clusterfilename,argv[5]);
	clustersOut=fopen(clusterfilename,"w");
	write_clusters(clustersOut,c);
	test();
}